
#include "TimerOne.h"

byte encoders;
long encoder_L;
byte encoder_new_L,  encoders_old, encoders_new, encoder_old_L, buttons_new;
byte sys_Bu1 = 0, sys_Bu2 = 0;
bool Bu1 = false, Bu2 = false;

//=================================================
void i_encoder() //Обработка по прерыванию энкодера
{
  if (Bu1) encoder_L = 0; // Сброс нуля.

  encoder_new_L = PINB & B11;
  buttons_new = PINB & B1100;

  if (encoder_new_L != encoder_old_L)
  {
    switch (encoder_old_L)
    {
      case 2:
        {
          if (encoder_new_L == 3) encoder_L++;
          if (encoder_new_L == 0) encoder_L--;
          break;
        }
      case 0:
        {
          if (encoder_new_L == 2) encoder_L++;
          if (encoder_new_L == 1) encoder_L--;
          break;
        }
      case 1:
        {
          if (encoder_new_L == 0) encoder_L++;
          if (encoder_new_L == 3) encoder_L--;
          break;
        }
      case 3:
        {
          if (encoder_new_L == 1) encoder_L++;
          if (encoder_new_L == 2) encoder_L--;
          break;
        }
    }
    encoder_old_L = encoder_new_L;
    // Записываем новое значение
    // Предыдущего состояния
  }

  //Обработка нажатич кнопок
  switch (buttons_new) // Если кнопаки не нажаты то на выходе число 3
  {
    case 8: // //Нажата 1 кнопка
      if (sys_Bu1 < 20) sys_Bu1++;
      else Bu1 = true;
      break;
    case 4: // //Нажата 2 кнопка
      if (sys_Bu2 < 20) sys_Bu2++;
      else Bu2 = true;
      break;
    default:
      Bu1 = false;
      Bu2 = false;
      sys_Bu2 = 0;
      sys_Bu1 = 0;
      break;
  }
}

void encoder_setup()
{
  //пины энкодера
  pinMode(8, INPUT);
  pinMode(9, INPUT);
  pinMode(10, INPUT); //button 1
  pinMode(11, INPUT);//button 2
  digitalWrite(10, HIGH); //button 1
  digitalWrite(11, HIGH); //button 2

  Timer1.initialize(20);  //longest pulse in PPM is usally 0.2 milliseconds,

  // encoder_L = 0;
  encoder_old_L = PINB & B11;
  Timer1.attachInterrupt(i_encoder);
}



