#include <EEPROM.h>
#include "ht1621_m.h"
#include "encoder.h"
unsigned long tme;
void button2_check()
{
  static long write_check;
  byte temp_b;
  if (Bu2) //Если нажата кнопка записи в энергонезависимую память
  {
    HT1621_all_on(16);
    if (write_check != encoder_L)
    {
      write_check = encoder_L;
      //Производим запись
      temp_b = write_check;
      EEPROM.write(0, temp_b);
      temp_b = write_check >> 8;
      EEPROM.write(1, temp_b);
      temp_b = write_check >> 16;
      EEPROM.write(2, temp_b);
      temp_b = write_check >> 24;
      EEPROM.write(3, temp_b);
      delay(10);
    }
  }
}
void load_from_EEPROM()
{
  long write_check;
  write_check = 0;
  write_check = EEPROM.read(0);
  write_check |= EEPROM.read(1) << 8;
  write_check |= EEPROM.read(2) << 16;
  write_check |= EEPROM.read(3) << 24;
  encoder_L = write_check;
}
void setup()
{
  load_from_EEPROM();
  Serial.begin(115200);
  setup_HT1621();
  encoder_setup();
  tme = millis() + 100;
}
void loop() {
  {
    if (tme < millis())
    {
      write_digit(encoder_L);
      //Serial.println(Bu2);
      tme = millis() + 100;
    }
    button2_check();
  }
}

